/*
 * myerror.h
 *
 * Copyright (C) 1994, Thomas G. Lane.
 * This file is part of the Independent JPEG Group's software.
 * For conditions of distribution and use, see the accompanying README file.
 *
 * This file defines the error and message codes for the cjpeg/djpeg
 * applications.  These strings are not needed as part of the JPEG library
 * proper.
 * Edit this file to add new codes, or to translate the message strings to
 * some other language.
 */


/* To define the enum list of message codes, include this file without
 * defining JMAKE_MSG_TABLE.  To create the message string table, include it
 * again with JMAKE_MSG_TABLE defined (this should be done in just one module).
 */


/* modified by Gnther Rhrich for use with jpegAGA */

#ifdef JMAKE_MSG_TABLE

const char * const addon_message_table[] = {

#define JMESSAGE(code,string)	string ,

#else /* not JMAKE_MSG_TABLE */

typedef enum {

#define JMESSAGE(code,string)	code ,

#endif /* JMAKE_MSG_TABLE */

JMESSAGE(JMSG_FIRSTADDONCODE=1000, NULL) /* Must be first entry! */

JMESSAGE(JERR_JPEGAGA_DISPLAY, "Could not open display")
JMESSAGE(JERR_JPEGAGA_MEMORY, "Out of memory")
JMESSAGE(JERR_JPEGAGA_MAPFILE, "Read error in mapfile")
JMESSAGE(JERR_JPEGAGA_NOMODE, "No screen mode selected")
JMESSAGE(JWRN_JPEGAGA_STOPPED, "Display stopped")
JMESSAGE(JERR_JPEGAGA_OPEN, "Can't open")

#ifdef JMAKE_MSG_TABLE

  NULL
};

#else /* not JMAKE_MSG_TABLE */

  JMSG_LASTADDONCODE
} ADDON_MESSAGE_CODE;

#endif /* JMAKE_MSG_TABLE */

#undef JMESSAGE
